summaryrefslogtreecommitdiff
path: root/rellns-sh
diff options
context:
space:
mode:
Diffstat (limited to 'rellns-sh')
-rwxr-xr-xrellns-sh67
1 files changed, 67 insertions, 0 deletions
diff --git a/rellns-sh b/rellns-sh
new file mode 100755
index 0000000000..f761b6bb77
--- /dev/null
+++ b/rellns-sh
@@ -0,0 +1,67 @@
+#! /bin/sh
+# rellns-sh - Simplified ln program to generate relative symbolic link.
+# Copyright (C) 1996 Free Software Foundation, Inc.
+# Written by Ulrich Drepper <drepper@cygnus.com>, October 1996
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2, or (at your option)
+# any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
+
+if test $# -ne 2; then
+ echo "Usage: rellns SOURCE DEST"
+ exit 1
+fi
+
+case $1 in
+/*)
+ # Make both paths absolute.
+ to=`echo $1 | sed 's%^/%%'`
+
+ if test -d $2; then
+ fromname=.
+ from=`echo $2 | sed 's%/$%%' | sed 's%^/%%'`
+ else
+ fromname=`echo $2 | sed 's%.*/\([^/]*\)$%\1%'`
+ from=`echo $2 | sed "s%/*$fromname$%%" | sed 's%^/%%'`
+ fi
+
+ case $from in
+ /*) ;;
+ ?*) from=`cd $from && pwd | sed 's%^/%%'` ;;
+ *) from=`pwd | sed 's%^/%%'` ;;
+ esac
+
+ while test -n "$to" && test -n "$from"; do
+ preto=`echo $to | sed 's%^\([^/]*\)/.*%\1%'`
+ prefrom=`echo $from | sed 's%^\([^/]*\)/.*%\1%'`
+
+ test "$preto" != "$prefrom" && break
+
+ to=`echo $to | sed 's%^[^/]*/\(.*\)$%\1%'`
+ from=`echo $from | sed 's%^[^/]*/\(.*\)$%\1%'`
+ done
+
+ while test -n "$from"; do
+ rfrom="../$rfrom"
+ from=`echo $from | sed 's%^[^/]*/*%%'`
+ done
+
+ ln -s $rfrom$to $2
+ ;;
+*)
+ # Nothing to do, the path is already relative.
+ ln -s $1 $2
+ ;;
+esac
+
+exit 0